
Ryzom - Feature # 947

Status: Closed Priority: Normal
Author: rti Category: OS: Mac
Created: 05/29/2010 Assignee: rti
Updated: 08/13/2010 Due date:
Subject: NeL/Ryzom: Run natively on Mac OS X using Cocoa
Description

As stated in the roadmap for 0.9 (http://dev.ryzom.com/versions/show/15) Ryzom should run natively on Mac OS X using Cocoa.
Therefor, the following things need to be done:
    -  CMake needs to build objective-c/c++
    -  the NeL OpenGL driver needs to implement the Cocoa interface for window creation and management, GL context creation
    -  a new CocoaEventEmitter needs to be implemented in NeL to handle mouse and keyboard events
    -  CMake build scripts need a new flag (eg. WITH_COCOA) to switch between X11 and Cocoa GL driver on Mac OS X
    -  CMake needs to create an App Bundle for Ryzom to match Mac OS X style
    -  ...

I have already a prototype implementation. After cleaning it up a bit I will sync it with the repository step by step.

Some more information on that topic are available on [[MacClientState]].

Related issues:
related to Ryzom - Feature # 41: Port NeL on Mac Closed 09/03/2008
related to Ryzom - Feature # 972: Do not reset mouse position to implement Fr... Closed 06/09/2010
related to Ryzom - Feature # 952: Use the same Mac key mapping with Cocoa and... Rejected 05/31/2010

History
#1 - 05/31/2010 11:03 pm - rti

Stuff added with #947

    -  objective-c / objective-c++ compilation and linking integrated into cmake based build process
    -  remove all X11 dependencies if built with option WITH_COCOA
    -  cmake creates an .app bundle
    -  native mac window opened by opengl_driver
    -  cocoa events handled in manual event loop
    -  ryzom client running with cocoa

Next steps

    -  dead keys and other key handling fixes
    -  mode switching
    -  fullscreen
    -  window resizing
    -  some basic menu items like quit and minimize
    -  review disabled gl extensions
    -  remove hardcoded values
    -  refactor

#2 - 06/03/2010 02:20 am - rti
- % Done changed from 10 to 20

#3 - 06/09/2010 12:31 am - rti
- % Done changed from 20 to 40

#4 - 06/09/2010 11:52 pm - rti
- % Done changed from 40 to 50

#5 - 06/11/2010 04:25 pm - rti
- % Done changed from 50 to 60

#6 - 06/12/2010 09:42 pm - rti
Remaining known issues:
    -  set Mouse pos on non main monitor
    -  crash with micro vegetation
    -  adapt kervalas driver changes (mode setting)
    -  replace depricated api used for getting modes

#7 - 06/12/2010 10:08 pm - rti

    -  mac style application menu still missing

#8 - 06/24/2010 10:31 pm - rti
Remaining known issues:
    -  replace deprecated api used for getting modes
        -  rethink the modes thing for mac since there is no real mode switch, just back buffer shrinking
    -  crash with micro vegetation
    -  in fullscreen mode, there is an empty window behind the full screen view, remove it / hide it
    -  mouse move events from the first monitor are "copied" to ryzom in fullscreen on the second monitor

#9 - 07/02/2010 11:36 am - rti

    -  check warnings provided by valgrind

#10 - 07/05/2010 04:45 pm - rti
- Status changed from Assigned to Resolved

closing this ticket now in favor of smaller ones to handle fine tuning tasks. 
ryzom core client runs on mac os x now.

#11 - 07/05/2010 04:45 pm - rti
- % Done changed from 60 to 100

#12 - 08/05/2010 06:32 pm - kervala
- Category changed from NeL: General to OS: Mac

#13 - 08/13/2010 05:43 pm - rti
- Status changed from Resolved to Closed

#14 - 08/13/2010 08:04 pm - rti
- Target version changed from Version 0.9.0 to Version 0.8.0
